.nolist
    include     \masm32\include\masm32rt.inc    ; defaults to .386
    .586
    include     timers.asm      ; requires a pentium
    LOOPCOUNT equ 100000;0
    
dwtoau proto :dword,:dword

ustrx$ MACRO DDvalue   ;; unsigned integer from string
	LOCAL rvstring
	.data
		rvstring db 20 dup (0)
	align 4
	.code
	invoke dwtoau,DDvalue,ADDR rvstring
	;invoke crt__ultoa,DDvalue,rvstring,10
	EXITM <OFFSET rvstring>
ENDM

.data

ttt db "abcde",0


; Note:  Timing tests are dependent upon the data and wether the routine checks for a-f or 0-9 first
 
TestData1 db 'ffffffff',0; = 4294967295',0
TestData2 db '01234567',0; = 19088743',0
TestData3 db '89ABCDEF',0; = 2309737967',0
TestData4 db 'abcdef',0; = 11259375',0
TestData5 db 'fFaA9@',0; = 1047209',0
TestData6 db '0f3h',0; = 243',0

tmp dd 0
ett dd 0


Procs textequ <5,6,7> ; <1,2,3,4,5>

%for sufx,<Procs>
	tot&sufx& dd 0
endm

.code

program:

for TD,<1,2,3,4,5,6>	; test data
	print chr$("Testing ")
	print offset TestData&TD&
	print chr$(13,10)
	%for sufx,<Procs>
		AsciiHexToDW&sufx& proto :dword
		print chr$("AsciiHexToDW&sufx& ")
           counter_begin LOOPCOUNT, REALTIME_PRIORITY_CLASS
		invoke AsciiHexToDW&sufx&,addr TestData&TD&
		mov	tmp,eax
           counter_end
           mov ett,eax
		   add tot&sufx&,eax  ; accumulate total time
		print ustrx$(tmp)
		print chr$("  size=")
		mov edx,endof&sufx&-AsciiHexToDW&sufx&
		print ustrx$(edx)
		print chr$("  cycles=")
		mov eax,ett
		print sstr$(eax)
		print chr$(13,10)
	endm
	print chr$(13,10)
endm		

	%for sufx,<Procs>
		print chr$("AsciiHexToDW&sufx& total time(cycles) = ")
		mov eax,tot&sufx&
		print sstr$(eax)
		print chr$(13,10)
	endm
	print chr$(13,10)

    mov   eax,input(13,10,"Press enter to exit...")
    exit

prtx:

; --------------------- Routines under test ---------------------------------------------

.code

align 16
AsciiHexToDW7 proc lpBuffer:dword
	xor eax,eax
	mov edx,lpBuffer
	jmp main2
mainloop:
doit:	
	shl eax,4	; *16
	add eax,ecx
next:
	add edx,1
main2:
	movzx ecx,byte ptr [edx]
	cmp ecx,48
	jb done		; below "0"
	and ecx,0dfh	; convert to lower case
	;cmp cl,"X"	; to allow 0x0000 format	;--- add in these two lines to allow 0x0000 format
	;je	next
	sub ecx,16	; assume 0-9  (0 thru 9 with bit masked off = 16 thru 25)
	cmp ecx,9
	jbe doit	; good, from "0" to "9"
	sub ecx,39	; assume A-F, convert to binary 10 thru 15
	cmp cl,10
	jb done		; invalid between "9" and "A"
	cmp ecx,15
	jbe doit	; else,	no good, after "F"
done:
	ret
AsciiHexToDW7 EndP
endof7:


align 16
AsciiHexToDW6 proc lpBuffer:dword
	xor eax,eax
	mov edx,lpBuffer
	jmp main2
mainloop:
doit:	
	shl eax,4	; *16
	add eax,ecx
next:
	add edx,1
main2:
	movzx ecx,byte ptr [edx]
	cmp cl,48
	jb done		; below "0"
	and cl,0dfh	; convert to lower case
	;cmp cl,"X"	; to allow 0x0000 format	;--- add in these two lines to allow 0x0000 format
	;je	next
	sub cl,16	; assume 0-9  (0 thru 9 with bit masked off = 16 thru 25)
	cmp cl,9
	jbe doit	; good, from "0" to "9"
	sub cl,39	; assume A-F, convert to binary 10 thru 15
	cmp cl,10
	jb done		; invalid between "9" and "A"
	cmp cl,15
	jbe doit	; else,	no good, after "F"
done:
	ret
AsciiHexToDW6 EndP
endof6:

align 16
AsciiHexToDW5 proc lpBuffer:dword
	xor eax,eax
	mov edx,lpBuffer
mainloop:
	movzx ecx,byte ptr [edx]
	cmp cl,48
	jb done		; below "0"
	and cl,0dfh	; convert to lower case
	;cmp cl,"X"	; to allow 0x0000 format	;--- add in these two lines to allow 0x0000 format
	;je	next
	sub cl,16	; assume 0-9  (0 thru 9 with bit masked off = 16 thru 25)
	cmp cl,9
	jbe doit	; good, from "0" to "9"
	sub cl,39	; assume A-F, convert to binary 10 thru 15
	cmp cl,10
	jb done		; invalid between "9" and "A"
	cmp cl,15
	ja done		; no good, after "F"
doit:	
	shl eax,4	; *16
	add eax,ecx
next:
	add edx,1
	jmp mainloop
done:
	ret
AsciiHexToDW5 EndP
endof5:

align 16
AsciiHexToDW4 proc  lpBuffer:dword
	xor eax,eax
	mov edx,lpBuffer
mainloop:
	movzx ecx,byte ptr [edx]
	cmp cl,102
	ja done
	cmp cl,96
	jbe @f
	sub cl,87
	jmp doit
@@:
	cmp cl,70
	ja done
	cmp cl,64
	jbe @f
	sub cl,55
	jmp doit
@@:
	cmp cl,57
	ja done
	cmp cl,48
	jb done
	sub cl,48
doit:
	shl eax,4
	add eax,ecx
	add edx,1
	jmp mainloop
done:	
	ret
AsciiHexToDW4 EndP
endof4:

align 16
AsciiHexToDW3 proc  lpBuffer:dword
	xor eax,eax
	mov edx,lpBuffer
mainloop:
	movzx ecx,byte ptr [edx]
	cmp cl,102
	ja done
	mov bl,87
	cmp cl,96
	ja subit
	cmp cl,70
	ja done
	mov bl,55
	cmp cl,64
	ja subit
	cmp cl,57
	ja done
	mov bl,48
	cmp cl,48
	jae subit
done:	
	ret
subit:
	sub cl,bl
	shl eax,4
	add eax,ecx
	add edx,1
	jmp mainloop
AsciiHexToDW3 EndP
endof3:

align 16
AsciiHexToDW2 proc lpBuffer:dword 
	xor eax,eax
	mov edx,lpBuffer
mainloop:
	movzx ecx,byte ptr [edx]
	.if cl > 96 && cl < 103 	;a et f
		sub cl,87
	.elseif cl > 64 && cl < 71 	;A et F
		sub cl,55
	.elseif cl >47 && cl < 58 	;0 et 9
		sub cl,48
	.else
		pop edx
		ret	; illegal character or done
	.endif
	shl eax,4
	add eax,ecx
	add edx,1
	jmp mainloop
AsciiHexToDW2 EndP
endof2:

align 16
AsciiHexToDW1 PROC uses esi lpBuffer:DWORD
Local  retour:DWORD
Local   long:DWORD
Local  resultat:DWORD
local  decale:DWORD
       mov retour,0
mov resultat,0
mov decale,0
invoke lstrlen,lpBuffer
.if eax == 0
stc ;carry flag error
jmp FindeAsciiHexToDW
.endif
mov esi,lpBuffer
mov long,eax
add esi,eax ;start at the right and go to left
dec esi
mov al,[esi]
.if al == "h" || al == "H" ;pass if H or h
dec esi
dec long
.if long == 0
                                               stc  ;carry flag error
jmp FindeAsciiHexToDW
.endif
.endif
.if long > 8
mov long,8 ;don't take care of digits that format the text
.endif
;there is only ascii digit in the string
newchar:
xor eax,eax
mov al,[esi]
.if al > 96 && al < 103 ;a et f
sub al,87
.elseif al > 64 && al < 71 ;A et F
sub al,55
.elseif al >47 && al < 58 ;0 et 9
sub al,48
.else
stc ;carry flag error
jmp FindeAsciiHexToDW
.endif
;the digit is translate in a number
mov ecx,decale
shl eax,cl ;shift left
add resultat,eax ;add to result
add decale,4
dec long
.if long == 0
push resultat ;all usable digit has been translate
pop retour
clc ;OK it's finish
jmp FindeAsciiHexToDW
.endif
dec esi
jmp newchar

;DWORD 8 chiffres max


FindeAsciiHexToDW:
         mov eax,retour
         ret
AsciiHexToDW1 endp
endof1:

; -------------------- misc routines -----------------
dwtoau proc dwValue:DWORD, lpBuffer:DWORD	; slightly modified from what masm32 lib's dwtoa

    push ebx
    push esi
    push edi

    mov eax, dwValue
    mov edi, [lpBuffer]

    test eax,eax
    jnz nonzero

    mov word ptr [edi],30h
    jmp dtaexit

 nonzero:
    mov ecx, 3435973837
    mov esi, edi

    .while (eax > 0)
      mov ebx,eax
      mul ecx
      shr edx, 3
      mov eax,edx
      lea edx,[edx*4+edx]
      add edx,edx
      sub ebx,edx
      add bl,'0'
      mov [edi],bl
      add edi, 1
    .endw
    mov byte ptr [edi], 0       ; terminate the string
    .while (esi < edi)
      sub edi, 1
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      add esi, 1
    .endw
 dtaexit:

    pop edi
    pop esi
    pop ebx

	ret
dwtoau endp


end program